package com.zipcodewilmington;

import java.util.Arrays;
import java.util.Hashtable;
import java.util.Map;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        String lastElement = array[array.length - 1];
        return lastElement;
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        String getSecondToLastElement = array[array.length - 2];
        return getSecondToLastElement;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for (String a : array) {

            if (a == value) {
                return true;
            }

        }

        return false;

    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] test = new String[array.length];

        int j = 0;

        for (int i = array.length - 1; i >= 0; i--) {
            test[j] = array[i];
            j++;
        }
        return test;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        for ( int i = 0; i < array.length; i++) {
            if (array[i].equals(array[array.length-1-i])){
                return true;
            }

        }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {

        int count = 0;
        String str = String.join(" ", array).toLowerCase();


        String [] alphabet = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"};

        for (int i = 0; i < alphabet.length; i++) {
            if(str.contains(alphabet[i])){
                count++;
            }
        }
        System.out.println(count);
        if (count >= 26) {

            return true;
        }
        return false;


    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;

        for (int i = 0; i < array.length; i++) {

            if (array[i] == value) {
                counter++;
            }
        }
        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        int x = getNumberOfOccurrences(array, valueToRemove);

        String[] array2 = new String[array.length - x];

        int counter = 0;

        for (int i = 0; i < array.length; i++) {
            if (array [i] != valueToRemove) {
                array2 [counter] = array [i];
                        counter++;


            }


        }
        return array2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        String [] str1 = new String[array.length];
        String lastValue = "";
        int counter = 0;

        for(int i = 0; i < array.length; i++) {

           if (!array[i].equals(lastValue)) {
               lastValue = array[i];
               str1[counter] = array[i];
               counter++;
           }
        }
        String [] str2 = Arrays.copyOf(str1, counter);
        return str2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        String [] str1 = new String[array.length];
        String lastVal = array[0];
        String running = array[0];
        int counter = 0;

        for (int i = 1; i < array.length; i++) {
            if(!array[i].equals(lastVal)) {
                lastVal = array[i];
                str1[counter] = running;
                running = array[i];
                counter++;


            }else {
                running = running + array[i];
            }
        }
        str1[counter] = running;

        String [] str2 = Arrays.copyOf(str1, counter+1 );


        return str2;
    }


}
